#!/usr/bin/perl
###################################################################
###      File: /home/users2/schmid/src/HyTagger/hmm-train.perl  ###
###    Author: Helmut Schmid                                    ###
###   Purpose:                                                  ###
###   Created: Thu May 19 16:06:28 2005                         ###
###  Modified: Fri May 20 16:53:37 2005 (schmid)                ###
### Copyright: Institut fuer maschinelle Sprachverarbeitung     ###
###               Universitaet Stuttgart                        ###
###################################################################


use Getopt::Std;
getopts('qp:');

$P = (defined $opt_p) ? $opt_p : 3;

print "$P\n";

for( $i=0; $i<$P; $i++ ) {
  push @prefix, '#';
}
push @suffix, '#-';

while (<>) {
  unless (defined $opt_q) {
    print STDERR "\r$M" if (++$M % 100 == 0);
  }
 
  s/\s*$//;
  s/ \| /% /g;
  @phon = @prefix;
  push @phon, split;
  push @phon, @suffix;
  $N = $#phon;
  for (my $i = $P; $i<=$N; $i++)
  {
      $phon[$i]=~s/^(.\-)/"\L$1"/e; $phon[$i]=~s/^\-/\-/; $phon[$i]=~s/^\-/\-/; $phon[$i]=~s/^\-/\-/;
      #$og = $1; $op = $2; $og_o = $og; 
      #$og = "\L$og";
      #$phon[$i]=~ /
  }
  for( $i=$N; $i>=$P; $i--) {
    $s = join(' ',@phon[$i-$P..$i]);
    $LF{$s}++;
  }
}

foreach $t (sort keys %LF) {
  printf "%s\t%d\n",$t,$LF{$t};
}

print STDERR "\n" unless defined $opt_q;
